## esptool 0.4.6

=== Makefile ===
CFLAGS		+= -std=gnu99 -Os -Wall
CXXFLAGS	+= -std=c++11 -Os -Wall


ifeq ($(OS),Windows_NT)
    TARGET_OS := WINDOWS
    DIST_SUFFIX := windows
    ARCHIVE_CMD := 7z a
    ARCHIVE_EXTENSION := zip
else
    UNAME_S := $(shell uname -s)
    ifeq ($(UNAME_S),Linux)
        TARGET_OS := LINUX
        UNAME_M := $(shell uname -m)
	    ifeq ($(UNAME_M),x86_64)
	        DIST_SUFFIX := linux64
	    endif
	    ifeq ($(UNAME_M),i686)
	        DIST_SUFFIX := linux32
	    endif
        ifeq ($(UNAME_M),armv6l)
            DIST_SUFFIX := linux-armhf
        endif
    endif
    ifeq ($(UNAME_S),Darwin)
        TARGET_OS := OSX
        DIST_SUFFIX := osx
    endif
    ARCHIVE_CMD := tar czf
    ARCHIVE_EXTENSION := tar.gz
endif

VERSION ?= $(shell git describe --always)

MODULES		:= infohelper elf binimage argparse serialport espcomm

-include local/Makefile.local.$(TARGET_OS)

OBJECTS		:= \
	argparse/argparse.o \
	argparse/argparse_binimagecmd.o \
	argparse/argparse_commcmd.o \
	argparse/argparse_elfcmd.o \
	binimage/esptool_binimage.o \
	elf/esptool_elf.o \
	elf/esptool_elf_object.o \
	espcomm/delay.o \
	espcomm/espcomm.o \
	espcomm/espcomm_boards.o \
	infohelper/infohelper.o \
	serialport/serialport.o \
	main.o

INCLUDES	:= $(addprefix -I,$(MODULES))

CFLAGS += $(TARGET_CFLAGS)
CXXFLAGS += $(TARGET_CXXFLAGS)
LDFLAGS += $(TARGET_LDFLAGS)
CPPFLAGS += $(INCLUDES) $(SDK_INCLUDES) -D$(TARGET_OS) -DVERSION=\"$(VERSION)\"

DIST_NAME := esptool-$(VERSION)-$(DIST_SUFFIX)
DIST_DIR := $(DIST_NAME)
DIST_ARCHIVE := $(DIST_NAME).$(ARCHIVE_EXTENSION)


.PHONY: all checkdirs clean dist

all: $(TARGET)

dist: $(TARGET) $(DIST_DIR)
	cp $(TARGET) $(DIST_DIR)/
	$(ARCHIVE_CMD) $(DIST_ARCHIVE) $(DIST_DIR)

$(TARGET): $(OBJECTS)
	$(CC) $^ -o $@ $(LDFLAGS)
	strip $(TARGET)

$(BUILD_DIR):
	@mkdir -p $@

$(DIST_DIR):
	@mkdir -p $@

clean:
	@rm -f $(OBJECTS)
	@rm -f $(TARGET)
	@rm -rf esptool-*

=== debian/changelog ===
esptool (0.4.6-1) unstable; urgency=medium

  * Initial release. (Closes: #811905)

 -- Milan Kupcevic <milan@debian.org>  Sun, 14 Feb 2016 19:55:50 -0500

=== debian/control ===
Source: esptool
Section: electronics
Priority: extra
Maintainer: Milan Kupcevic <milan@debian.org>
Build-Depends: 
 debhelper (>= 9),
 autoconf,
 automake,
 help2man
Standards-Version: 3.9.6
Homepage: https://github.com/igrr/esptool-ck/

Package: esptool
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: create and flash firmware files to ESP8266 or ESP32 chips
 Flash firmware files to ESP8266 or ESP32 boards with ability to 
 automatically put certain boards into UART bootloader programming mode. Or, 
 extract code sections from ELF executable files to create firmware images 
 for ESP chips.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

VER ?= $(shell dpkg-parsechangelog --show-field version \
               | sed -e "s,\(.*\)-.*,\\1," -e "s,.*:,,")

%:
	 dh $@

override_dh_auto_build:
	make VERSION=$(VER) esptool.1

get-orig-source:
	wget https://github.com/igrr/esptool-ck/archive/$(VER).tar.gz \
              -O esptool_$(VER).orig.tar.gz

=== debian/watch ===
version=3
https://github.com/igrr/esptool-ck/releases /igrr/esptool-ck/archive/v?(.+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## esptool 2.1+dfsg1

=== debian/changelog ===
esptool (2.1+dfsg1-2) sid; urgency=medium

  * Add package maintenance Vcs-* fields
  * Switch to python3
  * Add usage examples to the man pages

 -- Milan Kupcevic <milan@debian.org>  Sun, 05 Nov 2017 18:10:33 -0500

esptool (2.1+dfsg1-1) sid; urgency=medium

  * New upstream release
    - python based full support for ESP32 and ESP8266 chips
  * Disable flasher stub option due to DFSG removed binary blob

 -- Milan Kupcevic <milan@debian.org>  Tue, 24 Oct 2017 01:12:50 -0400

esptool (0.4.12-1) sid; urgency=medium

  * New upstream release.
    - Remove ESP32 support
  * Set package priority to optional.
  * Update standards version to 4.1.1. No changes.
  * Bump debhelper compatibility up to 10.
  * Also build on GNU/Hurd and GNU/kFreeBSD

 -- Milan Kupcevic <milan@debian.org>  Tue, 17 Oct 2017 22:29:14 -0400

=== debian/control ===
Source: esptool
Section: electronics
Priority: optional
Maintainer: Milan Kupcevic <milan@debian.org>
Build-Depends: 
 debhelper (>= 10),
 python3,
 python3-serial,
 python3-pyaes,
 python3-ecdsa,
 markdown,
 help2man
Standards-Version: 4.1.1
Vcs-Git: https://gitlab.com/debian/esptool.git
Vcs-Browser: https://gitlab.com/debian/esptool.git
Homepage: https://github.com/espressif/esptool

Package: esptool
Architecture: all
Multi-Arch: foreign
Depends: python3, python3-serial, python3-pyaes, python3-ecdsa, ${misc:Depends}
Description: create and flash firmware files to ESP8266 and ESP32 chips
 Communicate with the ROM bootloader in Espressif ESP8266 and ESP32 chips to
 fash firmware files, create firmware images or read OTP ROM or flash memory
 content such is manufacturer or device IDs.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

PTH  = $(abspath $(dir $(MAKEFILE_LIST)))
VER ?= $(shell dpkg-parsechangelog --file $(PTH)/changelog \
         --show-field version \
         | sed -e "s,\(.*\)-.*,\\1," -e "s,.*:,," -e "s,.dfsg[0-9]*,,")

%:
	dh $@

override_dh_auto_clean:
	rm -f *.pyc */*.pyc
	rm -f CONTRIBUTING.html
	rm -f esptool espefuse espsecure
	rm -f esptool.1 espefuse.1 espsecure.1

override_dh_auto_build:
	ln -s esptool.py esptool
	ln -s espsecure.py espsecure
	ln -s espefuse.py espefuse
	markdown --html4tags CONTRIBUTING.md > CONTRIBUTING.html
	help2man --no-info --section 1 --include=debian/see-also \
	  --source="Esptool.py $(VER)" \
	  -n "ESP8266 and ESP32 ROM Bootloader Utility" \
	  --version-string="$(VER)" \
	  ./esptool \
	  | sed -e "s,esptool.py,esptool," \
	  -e "s,Esptool.py,esptool.py," \
	  -e "s,esptool v[0-9]\+.*,," \
	  -e "s,\[.*\],," \
	  -e "s,sage: esptool,sage: esptool [OPTION] COMMAND," \
	  -e "s,positional arguments,command arguments," \
	  -e "s,\.\.\.,," \
	  -e "s,{load.*version},," \
	  -e "s/\\\fR {.*},/,/" \
	  > esptool.1
	help2man --no-info --section 1 --include=debian/see-also \
	  --source="Esptool.py $(VER)" \
	  -n "ESP32 Secure Boot & Flash Encryption tool" \
	  --version-string="$(VER)" \
	  ./espsecure \
	  | sed -e "s,espsecure.py,espsecure," \
	  -e "s,Esptool.py,esptool.py," \
	  -e "s,espsecure v[0-9]\+.*,," \
	  -e "s,\[.*\],," \
	  -e "s,sage: espsecure,sage: espsecure [OPTION] COMMAND," \
	  -e "s,positional arguments,command arguments," \
	  -e "s,\.\.\.,," \
	  -e "s,{digest.*data},," \
	  > espsecure.1
	help2man --no-info --section 1 --include=debian/see-also \
	  --source="Esptool.py $(VER)" \
	  -n "ESP32 efuse get/set tool" \
	  --version-string="$(VER)" \
	  ./espefuse \
	  | sed -e "s,espefuse.py,espefuse," \
	  -e "s,Esptool.py,esptool.py," \
	  -e "s,espefuse v[0-9]\+.*,," \
	  -e "s,\[.*\],," \
	  -e "s,sage: espefuse,sage: espefuse [OPTION] COMMAND," \
	  -e "s,positional arguments,command arguments," \
	  -e "s,\.\.\.,," \
	  -e "s,{dump.*voltage},," \
	  > espefuse.1

override_dh_auto_install:
	:

get-orig-source:
	uscan --no-conf \
	  --destdir=$(CURDIR) \
	  --rename \
	  --force-download \
	  --download-version $(VER) \
	  --check-dirname-level=0 \
	  $(PTH)

=== debian/watch ===
version=3
opts="compression=xz,repack,repacksuffix=+dfsg1,dversionmangle=s:.dfsg[0-9]*$::" https://github.com/espressif/esptool/releases /espressif/esptool/archive/v?(.+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz))) debian debian/uupdate

## esptool 2.5.1+dfsg

=== flasher_stub/Makefile ===
# Makefile to compile the flasher stub program
#
# Note that YOU DO NOT NEED TO COMPILE THIS IN ORDER TO JUST USE
# esptool.py - a precompiled version is embedded in esptool.py,
# so if you don't want to modify the stub code then you are good to go.
#
# See the comments in the top of the Makefile for parameters that
# you probably want to override.
#
# Copyright (c) 2016 Cesanta Software Limited & Angus Gratton
# All rights reserved
#
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
# Street, Fifth Floor, Boston, MA 02110-1301 USA.

# Adapted from Cesanta's original Makefile at
# https://github.com/cesanta/fnc/tree/master/common/platforms/esp8266/stubs

# Override these variables on the command line
# or set them in a local.mk
-include local.mk

# Prefix for ESP8266 & ESP32 cross compilers (can include a directory path)
CROSS_8266 ?= xtensa-lx106-elf-
CROSS_32 ?= xtensa-esp32-elf-

# Path to the ESP8266 SDK root dir
SDK_PATH ?= ../../esp_iot_sdk_v2.0.0

# Path to the esp-idf root dir
IDF_PATH ?= ../../esp-idf

# Python command to invoke wrap_stub.py
WRAP_STUB ?= ./wrap_stub.py

# Pass V=1 to see the commands being executed by make
ifneq ("$(V)","1")
Q = @
endif

STUB = stub_flasher
SRCS = stub_flasher.c slip.c stub_commands.c stub_write_flash.c
SRCS_8266 = miniz.c

BUILD_DIR = build

STUB_ELF_8266 = $(BUILD_DIR)/$(STUB)_8266.elf
STUB_ELF_32 = $(BUILD_DIR)/$(STUB)_32.elf
STUB_PY = $(BUILD_DIR)/$(STUB)_snippet.py

.PHONY: all clean

all: $(STUB_PY)

$(BUILD_DIR):
	$(Q) mkdir $@

CFLAGS = -std=c99 -Wall -Werror -Os \
         -mtext-section-literals -mlongcalls -nostdlib -fno-builtin -flto \
         -Wl,-static -g -ffunction-sections -Wl,--gc-sections

CFLAGS_8266 = $(CFLAGS) -I$(SDK_PATH) -I$(SDK_PATH)/include -L$(SDK_PATH)/ld
CFLAGS_32   = $(CFLAGS) -I$(IDF_PATH)/components/esp32/include -I$(IDF_PATH)/components/soc/esp32/include -L$(IDF_PATH)

$(STUB_ELF_8266): $(SRCS) $(SRCS_8266) $(BUILD_DIR) stub_8266.ld
	@echo "  CC(8266)   $^ -> $@"
	$(Q) $(CROSS_8266)gcc $(CFLAGS_8266) -DESP8266 -Tstub_8266.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^)

$(STUB_ELF_32): $(SRCS) $(BUILD_DIR) stub_32.ld
	@echo "  CC(32)   $^ -> $@"
	$(Q) $(CROSS_32)gcc $(CFLAGS_32) -DESP32 -Tstub_32.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^)

$(STUB_PY): $(STUB_ELF_8266) $(STUB_ELF_32) wrap_stub.py
	@echo "  WRAP $^ -> $@"
	$(Q) $(WRAP_STUB) $(filter %.elf,$^) $@

clean:
	$(Q) rm -rf $(BUILD_DIR)

=== debian/changelog ===
esptool (2.5.1+dfsg-3) sid; urgency=medium

  * update standards version to 4.3.0
  * add udev rules

 -- Milan Kupcevic <milan@debian.org>  Sun, 23 Dec 2018 23:51:11 -0500

esptool (2.5.1+dfsg-2) sid; urgency=medium

  * update man page copyright notice

 -- Milan Kupcevic <milan@debian.org>  Fri, 21 Dec 2018 08:20:07 -0500

esptool (2.5.1+dfsg-1) sid; urgency=medium

  [ Milan Kupcevic ]
  * new upstream release
  * update standards version to 4.2.1

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/control: Remove trailing whitespaces

 -- Milan Kupcevic <milan@debian.org>  Thu, 20 Dec 2018 21:16:47 -0500

esptool (2.5.0+dfsg-1) sid; urgency=low

  * New upstream release. (Closes: #906062)
    - update debian/copyright
  * Use discount instead of markdown.
  * Move package maintenance repository to salsa.
  * Update standards version to 4.2.0. No changes.
  * Update man page examples.

 -- Milan Kupcevic <milan@debian.org>  Sun, 26 Aug 2018 23:08:04 -0400

=== debian/control ===
--- 
+++ 
@@ -2,17 +2,17 @@
 Section: electronics
 Priority: optional
 Maintainer: Milan Kupcevic <milan@debian.org>
-Build-Depends: 
+Build-Depends:
  debhelper (>= 10),
  python3,
  python3-serial,
  python3-pyaes,
  python3-ecdsa,
- markdown,
+ discount,
  help2man
-Standards-Version: 4.1.1
-Vcs-Git: https://gitlab.com/debian/esptool.git
-Vcs-Browser: https://gitlab.com/debian/esptool.git
+Standards-Version: 4.3.0
+Vcs-Git: https://salsa.debian.org/debian/esptool.git
+Vcs-Browser: https://salsa.debian.org/debian/esptool
 Homepage: https://github.com/espressif/esptool
 
 Package: esptool

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 	dh $@
 
 override_dh_auto_clean:
-	rm -f *.pyc */*.pyc
+	rm -f *.pyc */*.pyc */*/*.pyc
 	rm -f CONTRIBUTING.html
 	rm -f esptool espefuse espsecure
 	rm -f esptool.1 espefuse.1 espsecure.1
@@ -20,7 +20,7 @@
 	ln -s esptool.py esptool
 	ln -s espsecure.py espsecure
 	ln -s espefuse.py espefuse
-	markdown --html4tags CONTRIBUTING.md > CONTRIBUTING.html
+	markdown CONTRIBUTING.md > CONTRIBUTING.html
 	help2man --no-info --section 1 --include=debian/see-also \
 	  --source="Esptool.py $(VER)" \
 	  -n "ESP8266 and ESP32 ROM Bootloader Utility" \
@@ -62,7 +62,7 @@
 	  -e "s,sage: espefuse,sage: espefuse [OPTION] COMMAND," \
 	  -e "s,positional arguments,command arguments," \
 	  -e "s,\.\.\.,," \
-	  -e "s,{dump.*voltage},," \
+	  -e "s,{dump.*_info},," \
 	  > espefuse.1
 
 override_dh_auto_install:

=== debian/watch ===
version=3
opts="compression=xz,repack,repacksuffix=+dfsg,dversionmangle=s:.dfsg[0-9]*$::" https://github.com/espressif/esptool/releases /espressif/esptool/archive/v?(.+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz))) debian debian/uupdate

## esptool 2.6+dfsg

=== debian/changelog ===
esptool (2.6+dfsg-1) sid; urgency=medium

  * new upstream release (closes: #922787)

 -- Milan Kupcevic <milan@debian.org>  Mon, 11 Mar 2019 13:10:15 -0400

## esptool 2.8%2Bdfsg

=== debian/changelog ===
esptool (2.8+dfsg-1~mx23) mx; urgency=medium

  * Rebuild for MX-23

 -- Timothy E. Harris <maintainer@mxrepo.com>  Fri, 17 Nov 2023 22:18:15 -0500

esptool (2.8+dfsg-1) sid; urgency=medium

  * new upstream release
  * update debian/copyright
  * update standards version to 4.5.0

 -- Milan Kupcevic <milan@debian.org>  Sat, 08 Feb 2020 11:05:01 -0500

## esptool 2.8+dfsg

=== flasher_stub/Makefile ===
--- 
+++ 
@@ -34,12 +34,6 @@
 CROSS_8266 ?= xtensa-lx106-elf-
 CROSS_32 ?= xtensa-esp32-elf-
 
-# Path to the ESP8266 SDK root dir
-SDK_PATH ?= ../../esp_iot_sdk_v2.0.0
-
-# Path to the esp-idf root dir
-IDF_PATH ?= ../../esp-idf
-
 # Python command to invoke wrap_stub.py
 WRAP_STUB ?= ./wrap_stub.py
 
@@ -67,16 +61,16 @@
 
 CFLAGS = -std=c99 -Wall -Werror -Os \
          -mtext-section-literals -mlongcalls -nostdlib -fno-builtin -flto \
-         -Wl,-static -g -ffunction-sections -Wl,--gc-sections
+         -Wl,-static -g -ffunction-sections -Wl,--gc-sections -Iinclude
 
-CFLAGS_8266 = $(CFLAGS) -I$(SDK_PATH) -I$(SDK_PATH)/include -L$(SDK_PATH)/ld
-CFLAGS_32   = $(CFLAGS) -I$(IDF_PATH)/components/esp32/include -I$(IDF_PATH)/components/soc/esp32/include -L$(IDF_PATH)
+CFLAGS_8266 = $(CFLAGS) -Iinclude/esp8266 -Lld
+CFLAGS_32   = $(CFLAGS) -Iinclude/esp32 -Lld
 
-$(STUB_ELF_8266): $(SRCS) $(SRCS_8266) $(BUILD_DIR) stub_8266.ld
+$(STUB_ELF_8266): $(SRCS) $(SRCS_8266) $(BUILD_DIR) ld/stub_8266.ld | Makefile
 	@echo "  CC(8266)   $^ -> $@"
 	$(Q) $(CROSS_8266)gcc $(CFLAGS_8266) -DESP8266 -Tstub_8266.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^)
 
-$(STUB_ELF_32): $(SRCS) $(BUILD_DIR) stub_32.ld
+$(STUB_ELF_32): $(SRCS) $(BUILD_DIR) ld/stub_32.ld | Makefile
 	@echo "  CC(32)   $^ -> $@"
 	$(Q) $(CROSS_32)gcc $(CFLAGS_32) -DESP32 -Tstub_32.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^)

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  python3-ecdsa,
  discount,
  help2man
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/debian/esptool.git
 Vcs-Browser: https://salsa.debian.org/debian/esptool
 Homepage: https://github.com/espressif/esptool

=== debian/rules ===
--- 
+++ 
@@ -62,7 +62,7 @@
 	  -e "s,sage: espefuse,sage: espefuse [OPTION] COMMAND," \
 	  -e "s,positional arguments,command arguments," \
 	  -e "s,\.\.\.,," \
-	  -e "s,{dump.*_info},," \
+	  -e "s,{dump.*_mac},," \
 	  > espefuse.1
 
 override_dh_auto_install:

## esptool 4.6.2+dfsg

=== flasher_stub/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # Makefile to compile the flasher stub program
 #
 # Note that YOU DO NOT NEED TO COMPILE THIS IN ORDER TO JUST USE
-# esptool.py - a precompiled version is embedded in esptool.py,
+# esptool.py - a precompiled version is included in esptool.py,
 # so if you don't want to modify the stub code then you are good to go.
 #
 # See the comments in the top of the Makefile for parameters that
@@ -30,9 +30,17 @@
 # or set them in a local.mk
 -include local.mk
 
-# Prefix for ESP8266 & ESP32 cross compilers (can include a directory path)
+# Prefix for each cross compiler (can include a directory path)
+# These can be overriden via environment variables or on the make command line
 CROSS_8266 ?= xtensa-lx106-elf-
 CROSS_32 ?= xtensa-esp32-elf-
+CROSS_32S2 ?= xtensa-esp32s2-elf-
+CROSS_32S3 ?= xtensa-esp32s3-elf-
+CROSS_ESPRISCV32 ?= riscv32-esp-elf-
+
+# extra CFLAGS to be passed on the compiler, in addition to the stock ones
+EXTRA_CFLAGS ?=
+EXTRA_CFLAGS_ESPRISCV32 ?=
 
 # Python command to invoke wrap_stub.py
 WRAP_STUB ?= ./wrap_stub.py
@@ -43,40 +51,125 @@
 endif
 
 STUB = stub_flasher
-SRCS = stub_flasher.c slip.c stub_commands.c stub_write_flash.c
+SRCS = stub_flasher.c slip.c stub_commands.c stub_write_flash.c stub_io.c
 SRCS_8266 = miniz.c
 
 BUILD_DIR = build
+ESPTOOL_STUBS_DIR = ../esptool/targets/stub_flasher
 
 STUB_ELF_8266 = $(BUILD_DIR)/$(STUB)_8266.elf
 STUB_ELF_32 = $(BUILD_DIR)/$(STUB)_32.elf
-STUB_PY = $(BUILD_DIR)/$(STUB)_snippet.py
+STUB_ELF_32S2 = $(BUILD_DIR)/$(STUB)_32s2.elf
+STUB_ELF_32S3_BETA_2 = $(BUILD_DIR)/$(STUB)_32s3beta2.elf
+STUB_ELF_32S3 = $(BUILD_DIR)/$(STUB)_32s3.elf
+STUB_ELF_32C3 = $(BUILD_DIR)/$(STUB)_32c3.elf
+STUB_ELF_32C6BETA = $(BUILD_DIR)/$(STUB)_32c6beta.elf
+STUB_ELF_32H2_BETA_1 = $(BUILD_DIR)/$(STUB)_32h2beta1.elf
+STUB_ELF_32H2_BETA_2 = $(BUILD_DIR)/$(STUB)_32h2beta2.elf
+STUB_ELF_32C2 = $(BUILD_DIR)/$(STUB)_32c2.elf
+STUB_ELF_32C6 = $(BUILD_DIR)/$(STUB)_32c6.elf
+STUB_ELF_32H2 = $(BUILD_DIR)/$(STUB)_32h2.elf
 
-.PHONY: all clean
+STUBS_ELF =
+ifneq ($(WITHOUT_ESP8266),1)
+STUBS_ELF += \
+  $(STUB_ELF_8266)
+endif
 
-all: $(STUB_PY)
+ifneq ($(WITHOUT_ESP32_XTENSA),1)
+STUBS_ELF += \
+  $(STUB_ELF_32) \
+  $(STUB_ELF_32S2) \
+  $(STUB_ELF_32S3_BETA_2) \
+  $(STUB_ELF_32S3)
+endif
+
+ifneq ($(WITHOUT_ESP32_RISCV32),1)
+STUBS_ELF += \
+  $(STUB_ELF_32C3) \
+  $(STUB_ELF_32C6BETA) \
+  $(STUB_ELF_32H2_BETA_1) \
+  $(STUB_ELF_32H2_BETA_2) \
+  $(STUB_ELF_32C2) \
+  $(STUB_ELF_32C6) \
+  $(STUB_ELF_32H2)
+endif
+
+.PHONY: all clean install
+
+all: $(STUBS_ELF:.elf=.json)
+
+install: $(patsubst $(BUILD_DIR)/%.elf,$(ESPTOOL_STUBS_DIR)/%.json,$(STUBS_ELF))
 
 $(BUILD_DIR):
 	$(Q) mkdir $@
 
+$(BUILD_DIR)/%.json: $(BUILD_DIR)/%.elf
+	@echo "  WRAP $^ -> $(BUILD_DIR)"
+	$(Q) $(WRAP_STUB) $^
+
+$(ESPTOOL_STUBS_DIR)/%.json: $(BUILD_DIR)/%.json
+	@echo "  INSTALL $^ -> $@"
+	$(Q) cp $^ $@
+
 CFLAGS = -std=c99 -Wall -Werror -Os \
          -mtext-section-literals -mlongcalls -nostdlib -fno-builtin -flto \
-         -Wl,-static -g -ffunction-sections -Wl,--gc-sections -Iinclude
-
-CFLAGS_8266 = $(CFLAGS) -Iinclude/esp8266 -Lld
-CFLAGS_32   = $(CFLAGS) -Iinclude/esp32 -Lld
+         -Wl,-static -g -ffunction-sections -Wl,--gc-sections -Iinclude -Lld \
+         $(EXTRA_CFLAGS)
+CFLAGS_ESPRISCV32 = -std=c99 -Wall -Werror -Os \
+		 -march=rv32imc -mabi=ilp32 -msmall-data-limit=0 \
+         -nostdlib -fno-builtin -flto \
+         -Wl,-static -g -ffunction-sections -Wl,--gc-sections -Iinclude -Lld \
+         $(EXTRA_CFLAGS_ESPRISCV32)
+LDLIBS = -lgcc
 
 $(STUB_ELF_8266): $(SRCS) $(SRCS_8266) $(BUILD_DIR) ld/stub_8266.ld | Makefile
 	@echo "  CC(8266)   $^ -> $@"
-	$(Q) $(CROSS_8266)gcc $(CFLAGS_8266) -DESP8266 -Tstub_8266.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^)
+	$(Q) $(CROSS_8266)gcc $(CFLAGS) -DESP8266=1 -Tstub_8266.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
 
 $(STUB_ELF_32): $(SRCS) $(BUILD_DIR) ld/stub_32.ld | Makefile
 	@echo "  CC(32)   $^ -> $@"
-	$(Q) $(CROSS_32)gcc $(CFLAGS_32) -DESP32 -Tstub_32.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^)
+	$(Q) $(CROSS_32)gcc $(CFLAGS) -DESP32=1 -Tstub_32.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
 
-$(STUB_PY): $(STUB_ELF_8266) $(STUB_ELF_32) wrap_stub.py
-	@echo "  WRAP $^ -> $@"
-	$(Q) $(WRAP_STUB) $(filter %.elf,$^) $@
+$(STUB_ELF_32S2): $(SRCS) $(BUILD_DIR) ld/stub_32s2.ld
+	@echo "  CC(32S2)   $^ -> $@"
+	$(Q) $(CROSS_32S2)gcc $(CFLAGS) -DESP32S2=1 -Tstub_32s2.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
+
+$(STUB_ELF_32S3_BETA_2): $(SRCS) $(BUILD_DIR) ld/stub_32s3_beta_2.ld
+	@echo "  CC(32S3)   $^ -> $@"
+	$(Q) $(CROSS_32S3)gcc $(CFLAGS) -DESP32S3=1 -DESP32S3BETA2=1 -Tstub_32s3_beta_2.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
+
+$(STUB_ELF_32S3): $(SRCS) $(BUILD_DIR) ld/stub_32s3.ld
+	@echo "  CC(32S3)   $^ -> $@"
+	$(Q) $(CROSS_32S3)gcc $(CFLAGS) -DESP32S3=1 -Tstub_32s3.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
+
+$(STUB_ELF_32C3): $(SRCS) $(BUILD_DIR) ld/stub_32c3.ld
+	@echo "  CC(32C3)   $^ -> $@"
+	$(Q) $(CROSS_ESPRISCV32)gcc $(CFLAGS_ESPRISCV32) -DESP32C3=1 -Tstub_32c3.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
+
+$(STUB_ELF_32C6BETA): $(SRCS) $(BUILD_DIR) ld/stub_32c6_beta.ld
+	@echo "  CC(32C6BETA)   $^ -> $@"
+	$(Q) $(CROSS_ESPRISCV32)gcc $(CFLAGS_ESPRISCV32) -DESP32C6BETA=1 -Tstub_32c6_beta.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
+
+$(STUB_ELF_32H2_BETA_1): $(SRCS) $(BUILD_DIR) ld/stub_32h2_beta_1.ld
+	@echo "  CC(32H2BETA1)   $^ -> $@"
+	$(Q) $(CROSS_ESPRISCV32)gcc $(CFLAGS_ESPRISCV32) -DESP32H2BETA1=1 -DESP32H2BETA1=1 -Tstub_32h2_beta_1.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
+
+$(STUB_ELF_32H2_BETA_2): $(SRCS) $(BUILD_DIR) ld/stub_32h2_beta_2.ld
+	@echo "  CC(32H2BETA2)   $^ -> $@"
+	$(Q) $(CROSS_ESPRISCV32)gcc $(CFLAGS_ESPRISCV32) -DESP32H2BETA2=1 -DESP32H2BETA2=1 -Tstub_32h2_beta_2.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
+
+$(STUB_ELF_32C2): $(SRCS) $(BUILD_DIR) ld/stub_32c2.ld
+	@echo "  CC(32C2)   $^ -> $@"
+	$(Q) $(CROSS_ESPRISCV32)gcc $(CFLAGS_ESPRISCV32) -DESP32C2=1 -Tstub_32c2.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
+
+$(STUB_ELF_32C6): $(SRCS) $(BUILD_DIR) ld/stub_32c6.ld
+	@echo "  CC(32C6)   $^ -> $@"
+	$(Q) $(CROSS_ESPRISCV32)gcc $(CFLAGS_ESPRISCV32) -DESP32C6=1 -Tstub_32c6.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
+
+$(STUB_ELF_32H2): $(SRCS) $(BUILD_DIR) ld/stub_32h2.ld
+	@echo "  CC(32H2)   $^ -> $@"
+	$(Q) $(CROSS_ESPRISCV32)gcc $(CFLAGS_ESPRISCV32) -DESP32H2=1 -Tstub_32h2.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
 
 clean:
 	$(Q) rm -rf $(BUILD_DIR)

=== debian/changelog ===
esptool (4.6.2+dfsg-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream version.
    - Drop flasher_stub patches, merged upstream (PR #856, #858),
      adjust debian/rules to the new upstream functionality.
    - Add dependency on python3-yaml, new since v4.6.
  * d/copyright: add link to a newly filed upstream issue for sourceless
    binaries in the upstream source package.
  * Release the new 4.x series to unstable.

 -- Faidon Liambotis <paravoid@debian.org>  Fri, 14 Jul 2023 01:05:45 +0300

esptool (4.5.1+dfsg-0.1) experimental; urgency=medium

  * Non-maintainer upload.
  * New upstream release. (Closes: #983719)
    - Update debian/copyright to match upstream changes.
    - Update build dependencies: drop python3-pyaes, and add
      python3-bitstring, python3-cryptography, python3-reedsolo and
      python3-pkcs11.
  * Compile and ship the flasher stub for ESP8266, as well as the ESP32 RISC-V
    variants (currently ESP32-C2, ESP32-C3, ESP32-C6, ESP32-H2). Notably, this
    does not include the ESP32 Xtensa variants (ESP32, ESP32-S2 and ESP32-S3)
    as there is no working toolchain in Debian for these. (Closes: #948096)
  * While the full test suite is stripped out and cannot be executed, add a
    few superficial autopkgtests: an autodep8 one, as well as smoke tests by
    running --help in the target environment.
  * Various package hygiene changes:
    - Revamp the build process to use dh-python, pybuild and setuptools to
      build and install the binaries. This means we now ship the "esptool"
      Python module for other packages to use. (Closes: #973031)
    - Drop upstream patch "shebang", as that is not necessary with pybuild.
    - Add Rules-Requires-Root: no, to indicate that the package does not need
      root to build.
    - Drop debian/NEWS, as it only included a news item for a version older
      than oldstable.
    - Add support for the "nodoc" build profile.
    - Add upstream metadata.
    - Bump debhelper compatibility level from 10 to 13.
    - Bump Standards-Version to 4.6.2.
    - Add gbp.conf and switch to DEP-14 branch naming.
  * Stop shipping CONTRIBUTING.md and its respective .html. Contributors are
    encouraged to look in the upstream GitHub repository for the latest
    information on how to contribute to the upstream project.

 -- Faidon Liambotis <paravoid@debian.org>  Fri, 17 Mar 2023 14:03:23 +0200

=== debian/control ===
Source: esptool
Section: electronics
Priority: optional
Maintainer: Milan Kupcevic <milan@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 dh-sequence-python3,
 python3-all,
 python3-bitstring,
 python3-cryptography,
 python3-ecdsa,
 python3-pkcs11,
 python3-reedsolo,
 python3-serial,
 python3-setuptools,
 python3-yaml,
 gcc-xtensa-lx106,
 picolibc-xtensa-lx106-elf,
 gcc-riscv64-unknown-elf,
 picolibc-riscv64-unknown-elf,
 help2man <!nodoc>,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-pybuild
Vcs-Git: https://salsa.debian.org/debian/esptool.git
Vcs-Browser: https://salsa.debian.org/debian/esptool
Homepage: https://github.com/espressif/esptool

Package: esptool
Architecture: all
Multi-Arch: foreign
Depends:
 ${python3:Depends},
 ${misc:Depends},
Recommends:
 ${python3:Recommends},
Suggests:
 ${python3:Suggests},
Description: create and flash firmware files to ESP8266 and ESP32 chips
 Communicate with the ROM bootloader in Espressif ESP8266 and ESP32 chips to
 fash firmware files, create firmware images or read OTP ROM or flash memory
 content such is manufacturer or device IDs.

## esptool 4.7.0+dfsg

=== docs/requirements.txt ===
esp-docs==1.4.*

=== flasher_stub/Makefile ===
--- 
+++ 
@@ -69,6 +69,7 @@
 STUB_ELF_32C2 = $(BUILD_DIR)/$(STUB)_32c2.elf
 STUB_ELF_32C6 = $(BUILD_DIR)/$(STUB)_32c6.elf
 STUB_ELF_32H2 = $(BUILD_DIR)/$(STUB)_32h2.elf
+STUB_ELF_32P4 = $(BUILD_DIR)/$(STUB)_32p4.elf
 
 STUBS_ELF =
 ifneq ($(WITHOUT_ESP8266),1)
@@ -92,7 +93,8 @@
   $(STUB_ELF_32H2_BETA_2) \
   $(STUB_ELF_32C2) \
   $(STUB_ELF_32C6) \
-  $(STUB_ELF_32H2)
+  $(STUB_ELF_32H2) \
+  $(STUB_ELF_32P4)
 endif
 
 .PHONY: all clean install
@@ -137,7 +139,7 @@
 
 $(STUB_ELF_32S3_BETA_2): $(SRCS) $(BUILD_DIR) ld/stub_32s3_beta_2.ld
 	@echo "  CC(32S3)   $^ -> $@"
-	$(Q) $(CROSS_32S3)gcc $(CFLAGS) -DESP32S3=1 -DESP32S3BETA2=1 -Tstub_32s3_beta_2.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
+	$(Q) $(CROSS_32S3)gcc $(CFLAGS) -DESP32S3BETA2=1 -Tstub_32s3_beta_2.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
 
 $(STUB_ELF_32S3): $(SRCS) $(BUILD_DIR) ld/stub_32s3.ld
 	@echo "  CC(32S3)   $^ -> $@"
@@ -153,11 +155,11 @@
 
 $(STUB_ELF_32H2_BETA_1): $(SRCS) $(BUILD_DIR) ld/stub_32h2_beta_1.ld
 	@echo "  CC(32H2BETA1)   $^ -> $@"
-	$(Q) $(CROSS_ESPRISCV32)gcc $(CFLAGS_ESPRISCV32) -DESP32H2BETA1=1 -DESP32H2BETA1=1 -Tstub_32h2_beta_1.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
+	$(Q) $(CROSS_ESPRISCV32)gcc $(CFLAGS_ESPRISCV32) -DESP32H2BETA1=1 -Tstub_32h2_beta_1.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
 
 $(STUB_ELF_32H2_BETA_2): $(SRCS) $(BUILD_DIR) ld/stub_32h2_beta_2.ld
 	@echo "  CC(32H2BETA2)   $^ -> $@"
-	$(Q) $(CROSS_ESPRISCV32)gcc $(CFLAGS_ESPRISCV32) -DESP32H2BETA2=1 -DESP32H2BETA2=1 -Tstub_32h2_beta_2.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
+	$(Q) $(CROSS_ESPRISCV32)gcc $(CFLAGS_ESPRISCV32) -DESP32H2BETA2=1 -Tstub_32h2_beta_2.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
 
 $(STUB_ELF_32C2): $(SRCS) $(BUILD_DIR) ld/stub_32c2.ld
 	@echo "  CC(32C2)   $^ -> $@"
@@ -171,5 +173,9 @@
 	@echo "  CC(32H2)   $^ -> $@"
 	$(Q) $(CROSS_ESPRISCV32)gcc $(CFLAGS_ESPRISCV32) -DESP32H2=1 -Tstub_32h2.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
 
+$(STUB_ELF_32P4): $(SRCS) $(BUILD_DIR) ld/stub_32p4.ld
+	@echo "  CC(32P4)   $^ -> $@"
+	$(Q) $(CROSS_ESPRISCV32)gcc $(CFLAGS_ESPRISCV32) -DESP32P4=1 -Tstub_32p4.ld -Wl,-Map=$(@:.elf=.map) -o $@ $(filter %.c, $^) $(LDLIBS)
+
 clean:
 	$(Q) rm -rf $(BUILD_DIR)

=== debian/changelog ===
esptool (4.7.0+dfsg-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.
    - Add new build dependency python3-intelhex. 

 -- Faidon Liambotis <paravoid@debian.org>  Fri, 26 Jan 2024 14:31:42 +0200

=== debian/control ===
--- 
+++ 
@@ -10,6 +10,7 @@
  python3-bitstring,
  python3-cryptography,
  python3-ecdsa,
+ python3-intelhex,
  python3-pkcs11,
  python3-reedsolo,
  python3-serial,

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export PYBUILD_NAME=esptool

UPSTREAM_VERSION = ${DEB_VERSION_UPSTREAM:+dfsg=}

%:
	dh $@ --buildsystem=pybuild

execute_after_dh_auto_install:
	mv debian/esptool/usr/bin/esptool.py debian/esptool/usr/bin/esptool
	mv debian/esptool/usr/bin/espefuse.py debian/esptool/usr/bin/espefuse
	mv debian/esptool/usr/bin/espsecure.py debian/esptool/usr/bin/espsecure
	dh_installexamples debian/esptool/usr/bin/esp_rfc2217_server.py
	rm -f debian/esptool/usr/bin/esp_rfc2217_server.py

execute_before_dh_auto_build:
	# uscan removes this entire directory through Files-Excluded
	mkdir esptool/targets/stub_flasher/
	# Build the stubs using the following options:
	# * Workaround "/usr/bin/env python" shebang in wrap_stub.py
	# * Disable ESP32 Xtensa stubs as we don't have toolchains for these
	# * Use the gcc/picolibc as found in Debian for ESP32 RISC-V chips
	# * Enable verbose mode
	make -C flasher_stub install \
	  WRAP_STUB="python3 wrap_stub.py" \
	  WITHOUT_ESP32_XTENSA=1 \
	  CROSS_ESPRISCV32=riscv64-unknown-elf- \
	  EXTRA_CFLAGS_ESPRISCV32=-specs=picolibc.specs \
	  V=1

override_dh_python3:
	# for python3-pkcs11, used by espsecure's HSM signing function
	dh_python3 --suggests-section=hsm

ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
execute_after_dh_auto_build: export PYTHONSAFEPATH=1
execute_after_dh_auto_build: export PYTHONPATH=$(shell pybuild --print build_dir --interpreter python3)
execute_after_dh_auto_build: PYTHON_SCRIPT_PATH=build/scripts-$(shell py3versions -v --max-supported)
execute_after_dh_auto_build:
	help2man --no-info --section 1 --include=debian/see-also \
	  --source="Esptool.py $(UPSTREAM_VERSION)" \
	  -n "ESP8266 and ESP32 ROM Bootloader Utility" \
	  --version-string="$(UPSTREAM_VERSION)" \
	  $(PYTHON_SCRIPT_PATH)/esptool.py \
	  | sed -e "s,esptool.py,esptool," \
	  -e "s,Esptool.py,esptool.py," \
	  -e "s,esptool v[0-9]\+.*,," \
	  -e "s,\[.*\],," \
	  -e "s,sage: esptool,sage: esptool [OPTION] COMMAND," \
	  -e "s,positional arguments,command arguments," \
	  -e "s,\.\.\.,," \
	  -e "s,{load.*version},," \
	  -e "s/{auto,.*}/{auto,CHIP}/" \
	  -e "s/\\\fR {.*},/,/" \
	  > esptool.1
	help2man --no-info --section 1 --include=debian/see-also \
	  --source="Esptool.py $(UPSTREAM_VERSION)" \
	  -n "ESP32 Secure Boot & Flash Encryption tool" \
	  --version-string="$(UPSTREAM_VERSION)" \
	  $(PYTHON_SCRIPT_PATH)/espsecure.py \
	  | sed -e "s,espsecure.py,espsecure," \
	  -e "s,Esptool.py,esptool.py," \
	  -e "s,espsecure v[0-9]\+.*,," \
	  -e "s,\[.*\],," \
	  -e "s,sage: espsecure,sage: espsecure [OPTION] COMMAND," \
	  -e "s,positional arguments,command arguments," \
	  -e "s,\.\.\.,," \
	  -e "s,{digest.*data},," \
	  > espsecure.1
	help2man --no-info --section 1 --include=debian/see-also \
	  --source="Esptool.py $(UPSTREAM_VERSION)" \
	  -n "ESP32 efuse get/set tool" \
	  --version-string="$(UPSTREAM_VERSION)" \
	  $(PYTHON_SCRIPT_PATH)/espefuse.py \
	  | sed -e "s,espefuse.py,espefuse," \
	  -e "s,Esptool.py,esptool.py," \
	  -e "s,espefuse v[0-9]\+.*,," \
	  -e "s,\[.*\],," \
	  -e "s,sage: espefuse,sage: espefuse [OPTION] COMMAND," \
	  -e "s,positional arguments,command arguments," \
	  -e "s,\.\.\.,," \
	  -e "s,{dump.*_mac},," \
	  -e "/^{burn_efuse,[^}]*}/d" \
	  -e "s/{auto,.*}/{auto,CHIP}/" \
	  > espefuse.1
endif

=== debian/tests/control ===
# smoke test the tools themselves
Test-Command: esptool --help | grep ^usage
Restrictions: superficial
Features: test-name=smoke-esptool

Test-Command: espefuse --help | grep ^usage
Restrictions: superficial
Features: test-name=smoke-espefuse

Test-Command: espsecure --help | grep ^usage
Restrictions: superficial
Features: test-name=smoke-espsecure

# also see the Testsuite field in d/control

=== debian/watch ===
version=4
opts="\
searchmode=plain,\
filenamemangle=s:.+/([^/]+)$:esptool-$1.tar.gz:,\
repack,\
repacksuffix=+dfsg,\
dversionmangle=s:.dfsg[0-9]*$::\
" \
https://api.github.com/repos/espressif/@PACKAGE@/releases \
https://api.github.com/repos/espressif/@PACKAGE@/tarball/v@ANY_VERSION@
